import { MatchData } from "./MatchData"
import { MessageData } from "./MessageData"

export interface OsuPacketWriter {
	// Functions
	LoginReply(data:number) : OsuPacketWriter,
	CommandError() : OsuPacketWriter,
	SendMessage(data:MessageData) : OsuPacketWriter,
	Ping() : OsuPacketWriter,
	HandleIrcChangeUsername(data:any) : OsuPacketWriter,
	HandleIrcQuit() : OsuPacketWriter,
	HandleOsuUpdate(data:any) : OsuPacketWriter,
	HandleUserQuit(data:any) : OsuPacketWriter,
	SpectatorJoined(data:any) : OsuPacketWriter,
	SpectatorLeft(data:any) : OsuPacketWriter,
	SpectateFrames(data:any) : OsuPacketWriter,
	VersionUpdate() : OsuPacketWriter,
	SpectatorCantSpectate(data:any) : OsuPacketWriter,
	GetAttention() : OsuPacketWriter,
	Announce(data:string) : OsuPacketWriter,
	MatchUpdate(data:MatchData) : OsuPacketWriter,
	MatchNew(data:any) : OsuPacketWriter,
	MatchDisband(data:any) : OsuPacketWriter,
	MatchJoinSuccess(data:any) : OsuPacketWriter,
	MatchJoinFail() : OsuPacketWriter,
	FellowSpectatorJoined(data:any) : OsuPacketWriter,
	FellowSpectatorLeft(data:any) : OsuPacketWriter,
	MatchStart(data:any) : OsuPacketWriter,
	MatchScoreUpdate(data:any) : OsuPacketWriter,
	MatchTransferHost(data:any) : OsuPacketWriter,
	MatchAllPlayersLoaded() : OsuPacketWriter,
	MatchPlayerFailed(data:any) : OsuPacketWriter,
	MatchComplete() : OsuPacketWriter,
	MatchSkip() : OsuPacketWriter,
	Unauthorised() : OsuPacketWriter,
	ChannelJoinSuccess(data:any) : OsuPacketWriter,
	ChannelAvailable(data:any) : OsuPacketWriter,
	ChannelRevoked(data:any) : OsuPacketWriter,
	ChannelAvailableAutojoin(data:any) : OsuPacketWriter,
	BeatmapInfoReply() : OsuPacketWriter,
	LoginPermissions(data:number) : OsuPacketWriter,
	FriendsList(data:Array<number>) : OsuPacketWriter,
	ProtocolNegotiation(data:number) : OsuPacketWriter,
	TitleUpdate(data:string) : OsuPacketWriter,
	Monitor() : OsuPacketWriter,
	MatchPlayerSkipped(data:any) : OsuPacketWriter,
	UserPresence(data:any) : OsuPacketWriter,
	Restart(data:any) : OsuPacketWriter,
	Invite(data:any) : OsuPacketWriter,
	ChannelListingComplete() : OsuPacketWriter,
	MatchChangePassword(data:any) : OsuPacketWriter,
	BanInfo(data:any) : OsuPacketWriter,
	UserSilenced(data:any) : OsuPacketWriter,
	UserPresenceSingle(data:any) : OsuPacketWriter,
	UserPresenceBundle(data:any) : OsuPacketWriter,
	UserPMBlocked(data:any) : OsuPacketWriter,
	TargetIsSilenced(data:any) : OsuPacketWriter,
	VersionUpdateForced() : OsuPacketWriter,
	SwitchServer(data:any) : OsuPacketWriter,
	AccountRestricted() : OsuPacketWriter,
	RTX(data:any) : OsuPacketWriter,
	SwitchTourneyServer(data:any) : OsuPacketWriter

	toBuffer : Buffer
}